#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0


extern bool   ModeTotal  = true;
extern string UniqueID   = "SwingVolume1";
extern color  ColorUp    = LimeGreen;
extern color  ColorDn    = Red;
extern int    Width      = 0;
extern bool   DrawAsBack = false;

//

double totUpf[];
double totDnf[];
double totUp[];
double totDn[];
double dir[];
double swing[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,totUpf); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"UpSwingVolume");
   SetIndexBuffer(1,totDnf); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"DownSwingVolume");
   SetIndexBuffer(2,totUp);
   SetIndexBuffer(3,totDn);
   SetIndexBuffer(4,dir);
   SetIndexBuffer(5,swing);
      IndicatorDigits(0);
      IndicatorShortName("SwingVolume");
   return(0);
}
int deinit()
{
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
         if (StringFind(name,UniqueID+":")==0) ObjectDelete(name);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
               for (;limit<Bars-1; limit++) if (dir[limit]!=dir[limit+1]) break;
           
   //
   //
   //
   //
   //
   
   for(int i = limit; i >= 0; i--)
   {
      double currSwing = iCustom(NULL,0,"ay-SwingClose",0,i);
      if (currSwing==EMPTY_VALUE)
            swing[i] = swing[i+1];
      else  swing[i] = currSwing;        

      //
      //
      //
      //
      //
      
      dir[i-1] = dir[i];
         if (swing[i]>swing[i+1]) dir[i-1] = -1;
         if (swing[i]<swing[i+1]) dir[i-1] =  1;

         totUp[i] = 0;
         totDn[i] = 0;
            if (dir[i]== 1) totUp[i] = totUp[i+1]+Volume[i];
            if (dir[i]==-1) totDn[i] = totDn[i+1]+Volume[i];
         totUpf[i] = totUp[i];
         totDnf[i] = totDn[i];

         if (ModeTotal)
            for (int k=1; (i+k)<Bars; k++)
               if (dir[i+k]==dir[i])
               {
                  if (dir[i]==1)
                     totUpf[i+k] = totUp[i];
                     totDnf[i+k] = totDn[i];
               }
               else break; 
               
         //
         //
         //
         //
         //
         
         if (UniqueID!="")
         {
            string name = UniqueID+":"+Time[i]; ObjectDelete(name);
            
               //
               //
               //
               //
               //
               
               for (k=0; (i+k)<Bars; k++) if (dir[i+k+1]!=dir[i]) break;
               if (k!=0)
               {
                  name = UniqueID+":"+Time[i+k];
                     ObjectCreate(name,OBJ_RECTANGLE,0,0,0,0,0);
                        ObjectSet(name,OBJPROP_TIME1,Time[i+k]);
                        ObjectSet(name,OBJPROP_TIME2,Time[i]);
                        if (dir[i]==1)
                        {
                           ObjectSet(name,OBJPROP_PRICE1,Low[ArrayMinimum(Low,k+1,i)]);
                           ObjectSet(name,OBJPROP_PRICE2,High[ArrayMaximum(High,k+1,i)]);
                           ObjectSet(name,OBJPROP_COLOR ,ColorUp);
                        }
                        else
                        {
                           ObjectSet(name,OBJPROP_PRICE1,High[ArrayMaximum(High,k+1,i)]);
                           ObjectSet(name,OBJPROP_PRICE2,Low[ArrayMinimum(Low,k+1,i)]);
                           ObjectSet(name,OBJPROP_COLOR ,ColorDn);
                        }
                        ObjectSet(name,OBJPROP_BACK,DrawAsBack);
                        ObjectSet(name,OBJPROP_WIDTH,Width);
               }                        
         }                                      
   }
   return(0);
}

